SystemOrganization addCategory: #Sanity!

Object subclass: #Sanity
	instanceVariableNames: 'machines text listeMachines'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sanity'!

!Sanity commentStamp: 'xm 1/11/2013 11:29' prior: 0!
Lancement

Sanity ssh srv: 'nomMachine'
Sanity ssh ip: 'IPSRV'



+ Lire le fichier ref_machine : fichier et http
  - Mettre en ligne le fichier, donc rajouter la conf vhost et rajouter dans les scripts pour le mettre en ligne
+ tester si un lien ssh master est dispo pour une machine en particulier
- crer un lien master ssh
- lancer une connexion ssh via le lien master

Fonctions :

- Carte d'identit de la machine
  - Machine virtuelle ?
  - type d'OS : Linux (redhat / suse) / BSD / AIX
  - autodiag

- Liste des utilisateurs prsents
- Liste des process en cours -> rafraichissement
- Graphique sur le fonctionnement de la machine
  - CPU
  - Mmoire
  - IO sur l'ensemble des disques ou par disques ?
  - Cration d'un morph type Gauge
  - Charge rseau
  - Load average du serveur

Samu

- Interface pour la connexion via le samu
- Envoie des informations via un GET ou POST sur un WS en CGI!

!Sanity methodsFor: 'UI' stamp: 'xm 1/13/2013 13:31'!
affListeMachines
	"Prompt pour selectionner une machine"
	"--> MorphTreeModel ne convient pas, la souris est bloque il faut trouver pkoi ???"
	Cursor wait 
	showWhile: [
		^ MorphTreeModel new
			beCheckList;
			rootItems: (listeMachines sort: [:a :b | a name <= b name]) ;
			 headerLabel: 'Choisir un serveur';
			 openDialogWindowIn: World title: 'Liste des serveurs']! !

!Sanity methodsFor: 'UI' stamp: 'xm 1/12/2013 16:08'!
affListeOperations
	"comment stating purpose of message"
! !

!Sanity methodsFor: 'refMachine' stamp: 'xm 1/13/2013 13:19'!
decodeRefMachine: aContent
	"Ici on dcode le contenu du fichier rcupr
	MACHINE:NUMSRV:IP:SSHPORT:VLAN:OSTYPE:OPT1:OPT2:OPT3:OPT4
	Le dcodage va crer un tableau avec des rfrences de tableaux .... optimum ?
	"
	|line stream|
	stream := ReadStream on: aContent.
	[(line := stream nextLine) notNil]
		whileTrue: [
			"On ne tient pas compte des lignes de commentaire"
			(line matchesRegex: '^#(.*)') ifFalse: [
				|field machineName|
				field := line findTokens: ':'. "On dcoupe la ligne"
				machineName := field at: 1. "On rcupre le premier lment"
				field removeAt: 1. "On le supprime"
				listeMachines add: machineName. "On rajoute la machine dans la liste"
				machines at: machineName put: field.
				].
		].! !

!Sanity methodsFor: 'refMachine' stamp: 'xm 12/21/2012 15:33'!
getRefMachine
	"Lit le fichier les informations de connexion des machines.
	On test dans un premier temps la version http, si ce n'est pas dispo (down, 404 ...)
	alors on se rabat sur la version texte.
	"

	| contenu |
	"ifTrue: [Transcript show: 'On lit le fichier directement en http'];"
	(contenu := self readRefMachineFromHttp)
		ifFalse: [ contenu := self readRefMachineFromFile ].
	self decodeRefMachine: contenu.! !

!Sanity methodsFor: 'initialize' stamp: 'xm 1/11/2013 13:43'!
initialize 
	"Initialise l'environnement pour les connexions aux machines
	Le ref_machine est lu  ce moment l vu qu'il sera utilis par toutes les autres mthodes.
	"
	super initialize.
	machines := Dictionary new.
	listeMachines := OrderedCollection new.
	self getRefMachine.! !

!Sanity methodsFor: 'sshMaster' stamp: 'xm 1/13/2013 13:43'!
isSSHConnMasterPresent: aMachine
	"Vrifie si une machine possde dj une connexion SSH Master"
	|aPort|
	aPort:='22'. "Ce paramtre est a rcuprer dans le fichier ref_machines.conf"
	^self isSSHConnMasterPresent: aMachine port: aPort.! !

!Sanity methodsFor: 'sshMaster' stamp: 'xm 1/13/2013 13:43'!
isSSHConnMasterPresent: aMachine port: aPort
	"vrifie sur une connexion master SSH sur le port PORT est dj prsente"
	"Le login doit tre mis en paramtre via une prfrence"
	| cmd str exitCode |
	str := 'ps -efwww | grep "ssh -MNf -p ',aPort,' messner@' , aMachine , '" | grep -v grep | grep -v /bin/sh'.
	"cmd:=(PipeableOSProcess command: str) output."
	cmd := OSProcess waitForCommand: str.
	exitCode := cmd exitStatus.
	exitCode = 0
		ifFalse: [ ^ false ]
		ifTrue: [ ^ true ]! !

!Sanity methodsFor: 'refMachine' stamp: 'xm 1/11/2013 14:01'!
listeMachines
	^listeMachines.! !

!Sanity methodsFor: 'print' stamp: 'xm 1/11/2013 15:46'!
print
	"Affiche la liste des machines"
	Transcript show: listeMachines.! !

!Sanity methodsFor: 'refMachine' stamp: 'xm 1/13/2013 13:20'!
readRefMachineFromFile
	"Charge le fichier en mmoire et ensuite le dcode"
	| file |
	file := FileStream readOnlyFileNamed: '/etc/ref_machines.conf'.
	^(file contents).! !

!Sanity methodsFor: 'refMachine' stamp: 'xm 1/13/2013 13:20'!
readRefMachineFromHttp
	"comment stating purpose of message"

	|response headers|
	response := ZnClient new enforceHttpSuccess: true;
	"ifFail: [:exception | self inform: 'Erreur',exception printString];"
	ifFail: [^false];
	get: 'http://localhost/ref_machine.conf';response.
	^(response code == 200).! !

!Sanity methodsFor: 'ssh' stamp: 'xm 1/12/2013 16:26'!
ssh
	"Lance une connexion SSH vers une machine prsente dans le fichier"
	|machine|
	machine := self affListeMachines.
	machine ifNil: [Transcript show: 'Pas de machine selectionne';cr] ifNotNil: [self ssh: (machine at: 1)].

	! !

!Sanity methodsFor: 'ssh' stamp: 'xm 1/12/2013 17:14'!
ssh: aMachine
	"Lance une connexion SSH avec un serveur
	La machine sera rcupre du ref_machine
	On valide que la connexion master est prsente
	sinon on la cre
	puis ensuite on va se connecter
	"

	(self isSSHConnMasterPresent: aMachine) ifFalse: [Transcript show: 'La connexion master pour ',aMachine,' n''est pas active';cr] ifTrue: [Transcript show: 'La connexion ',aMachine,' existe';cr].! !

!Sanity methodsFor: 'sshMaster' stamp: 'xm 1/13/2013 13:44'!
sshMasterConn: aMachine
	"comment stating purpose of message"
	"Le port est a rcuprer via le fichier"
	self sshMasterConn: aMachine port:  '22'.! !

!Sanity methodsFor: 'sshMaster' stamp: 'xm 1/13/2013 13:44'!
sshMasterConn: aMachine port: port
	"comment stating purpose of message"
	"Le login est  rcuprer via une variable de prfrence"
	self sshMasterConn: aMachine port: port login: 'messner'! !

!Sanity methodsFor: 'sshMaster' stamp: 'xm 1/13/2013 13:45'!
sshMasterConn: aMachine port: port login: login
	"comment stating purpose of message"
	"La commande est a forger via une prfrence de l'utilisateur"
	|cmd str|
	str := 'xterm -e "ssh -MNf -p ',port,' ',login,'@',aMachine,'"'.
	Transcript show: str;cr.
	cmd:=UnixProcess command: str.! !

!Sanity methodsFor: 'ssh' stamp: 'xm 1/11/2013 11:38'!
sshOnIp: aMachine withPort: aPort
	"Lance une connexion SSH avec un serveur"

	| temporary variable names statements |
	statements! !

!Sanity methodsFor: 'ssh' stamp: 'xm 1/11/2013 11:37'!
sshOnSrv: aMachine withPort: aPort
	"Lance une connexion SSH avec un serveur"

	| temporary variable names statements |
	statements! !
